package org.vtokarev.controller;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.vtokarev.domain.RoomRequest;
import org.vtokarev.domain.RoomRequestStatus;
import org.vtokarev.service.BookingService;
import org.vtokarev.service.RoomRequestService;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.lang.invoke.MethodHandles;
import java.time.LocalDate;
import java.time.format.DateTimeParseException;
import java.util.Optional;

/**
 * The {@code BookRoomManagerServlet} class implements {@code doPost} method that processes POST {@code bookRoomManager} requests generated by users with MANAGER role.
 * In the {@code doPost} method, it collects the necessary data from the MANAGER request and create {@link org.vtokarev.domain.Booking}.
 * Once booking is processed(created or declined), it forwards the control to {@code requestList} to process other MANAGER requests.
 *
 * @author Vyacheslav Tokarev
 */


@WebServlet(urlPatterns = "/bookRoomManager", name = "bookRoomManagerServlet")
public class BookRoomManagerServlet extends HttpServlet {

    private final static Logger LOGGER = LogManager.getLogger(MethodHandles.lookup().lookupClass());
    private RoomRequestService roomRequestService;
    private BookingService bookingService;

    @Override
    public void init(ServletConfig config) throws ServletException {
        roomRequestService = (RoomRequestService) config.getServletContext().getAttribute("app/RoomRequestService");
        bookingService = (BookingService) config.getServletContext().getAttribute("app/BookingService");
    }

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws IOException {
        if (req.getParameter("requestId") == null) {
            resp.sendRedirect("requestList");
            return;
        }

        long requestId;
        try {
            requestId = Long.parseLong(req.getParameter("requestId"));
        } catch (NumberFormatException | DateTimeParseException e) {
            LOGGER.warn("Failed to parse request param doPost");
            resp.sendRedirect("requestList");
            return;
        }

        if (req.getParameter("empty") != null) {
            Optional<RoomRequest> roomRequest = roomRequestService.get(requestId);
            final String managerNotesEmptyList = req.getParameter("managerNotes");
            roomRequest.ifPresent(rr -> {
                rr.setStatus(RoomRequestStatus.CANCELLED);
                rr.setManagerNotes(managerNotesEmptyList);
                roomRequestService.update(rr);
            });
            resp.sendRedirect("requestList");
            return;
        }

        if (req.getParameter("checkin") == null ||
                req.getParameter("checkout") == null ||
                req.getParameter("roomId") == null ||
                req.getParameter("price") == null) {
            resp.sendRedirect("requestList");
            return;
        }

        long userId = 0;
        LocalDate checkin = null;
        LocalDate checkout = null;
        long roomId = 0;
        double price = 0d;
        String managerNotes = "";

        try {
            checkin = LocalDate.parse(req.getParameter("checkin"));
            checkout = LocalDate.parse(req.getParameter("checkout"));
            roomId = Long.parseLong(req.getParameter("roomId"));
            price = Double.parseDouble(req.getParameter("price"));
            requestId = Long.parseLong(req.getParameter("requestId"));
            userId = Long.parseLong(req.getParameter("userId"));
            managerNotes = req.getParameter("managerNotes");
        } catch (NumberFormatException | DateTimeParseException e) {
            LOGGER.warn("Failed to parse request param doPost");
            resp.sendRedirect("requestList");
        }

        String errorMessage = bookingService.bookRoom(userId, roomId, price, checkin, checkout, requestId, managerNotes);
        resp.sendRedirect("requestList" + (errorMessage == null ? "" : "?errorMessage=" + errorMessage));
    }
}
